#!/usr/bin/env python

import EMAN
import math
import sys

def changeValue(data,x,y,z):
	neighbors = []
	nx = data.xSize()
	ny = data.ySize()
	nz = data.zSize()
	
	for neighbor_z in range(z-1,z+2):
		for neighbor_y in range(y-1,y+2):
			for neighbor_x in range(x-1,x+2):
				if (neighbor_z>=0) and (neighbor_z<nz) and (neighbor_y>=0) and (neighbor_y<ny) and (neighbor_x>=0) and (neighbor_x < nx):
					neighbors.append(data.valueAt(neighbor_x,neighbor_y,neighbor_z))
 	neighbors.sort()
	median = neighbors[int(math.floor(len(neighbors)/2))]
	data.setValueAt(x,y,z,median)


def speckle_filter(data):
	mean = data.Mean()
	stdev = data.Sigma()
	
	x,y,z = data.MinLoc()
	value  = data.valueAt(x,y,z)
	#print mean
	#print value
	#print stdev
	while (((value - mean)/stdev) > 5.0):
		changeValue(data,x,y,z)
		x,y,z = data.MinLoc()
		value  = data.valueAt(x,y,z)
	return data	
	



def main():
	if len(sys.argv) != 3:
		print "Usage::  %s <input particles file name> <output particles file name>"%(sys.argv[0])
		sys.exit(-1)
	input = sys.argv[1]
	output = sys.argv[2]
	
	stack=EMAN.readImages(input,-1,-1)
	i = 0
	for image in stack:
		#print "writing image %s"%(i)
		new_image = speckle_filter(image)
		new_image.writeImage(output,i)
		i=i+1

if __name__ == '__main__':
	main()
