import chimera.extension
import threading
import os
import time

# -----------------------------------------------------------------------------
#
class helixhunter_EMO(chimera.extension.EMO):
	def name(self):
		return "Helixhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs helixhunter2'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('hhc').gui()

		return None

chimera.extension.manager.registerExtension(helixhunter_EMO(__file__))

class foldhunter_EMO(chimera.extension.EMO):
	def name(self):
		return "Foldhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs AIRS foldhunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('fhc').gui()

		return None

chimera.extension.manager.registerExtension(foldhunter_EMO(__file__))

class hh3c_EMO(chimera.extension.EMO):
	def name(self):
		return "Helixhunter3"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'Super-mega-ultra-hyper-helixhunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('hh3c').gui()

		return None

chimera.extension.manager.registerExtension(hh3c_EMO(__file__))

class bilateral_EMO(chimera.extension.EMO):
       def name(self):
	       return "Bilateral Filter"

       def categories(self):
	       "Return list of category names in which this extension belongs"
	       return ["AIRS"]

       def description(self):
	       "Return short description (appropriate for balloon help)"
	       return 'bilateral filter'

       def documentation(self):
	       "Return full documention URL"
	       return None

       def hasUI(self):
	       "Return whether extension activation starts a UI"
	       return 1

       def activate(self):
	       "Activate extension and return an instance (if appropriate)"
	       self.module('bfc').gui()

	       return None

chimera.extension.manager.registerExtension(bilateral_EMO(__file__))

#class sheethunter_EMO(chimera.extension.EMO):
#	def name(self):
#		return "Sheethunter"
#
#	def categories(self):
#		"Return list of category names in which this extension belongs"
#		return ["AIRS"]
#
#	def description(self):
#		"Return short description (appropriate for balloon help)"
#		return 'runs EMAN sheethunter2'
#
#	def documentation(self):
#		"Return full documention URL"
#		return None
#
#	def hasUI(self):
#		"Return whether extension activation starts a UI"
#		return 1
#
#	def activate(self):
#		"Activate extension and return an instance (if appropriate)"
#		self.module('shc').gui()
#
#		return None
#
#chimera.extension.manager.registerExtension(sheethunter_EMO(__file__))

class sshunter_EMO(chimera.extension.EMO):
	def name(self):
		return "SSEhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs ssehunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('ssc').gui()

		return None

chimera.extension.manager.registerExtension(sshunter_EMO(__file__))

class ssebuilder_EMO(chimera.extension.EMO):
	def name(self):
		return "SSEbuilder"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs ssebuilder'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('ssebuilder').gui()

		return None

chimera.extension.manager.registerExtension(ssebuilder_EMO(__file__))

class modeviewer_EMO(chimera.extension.EMO):
	def name(self):
		return "ModeViewer"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs modeviewer'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('modeviewer').gui()

		return None

chimera.extension.manager.registerExtension(modeviewer_EMO(__file__))

class AIRS_EMO(chimera.extension.EMO):
       def name(self):
	       return "AIRS"

       def categories(self):
	       "Return list of category names in which this extension belongs"
	       return ["AIRS"]

       def description(self):
	       "Return short description (appropriate for balloon help)"
	       return 'runs AIRS'

       def documentation(self):
	       "Return full documention URL"
	       return None

       def hasUI(self):
	       "Return whether extension activation starts a UI"
	       return 1

       def activate(self):
	       "Activate extension and return an instance (if appropriate)"
	       self.module('AIRS').gui()

	       return None

chimera.extension.manager.registerExtension(AIRS_EMO(__file__))

class flexible_EMO(chimera.extension.EMO):
	def name(self):
		return "Flexible Foldhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'Flexible Foldhunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('flexible').gui()

		return None

chimera.extension.manager.registerExtension(flexible_EMO(__file__))
