import os
import sys
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox
import chimera
import VolumeViewer

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window

class bilateral(ModelessDialog):
	name = "bfc ui"
	buttons = ("Apply","Close")
	title = "bilateral filter"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/blfilt_help.html"%(direman)
	help = hellp

        def volume_data_set(self, model):
                d = VolumeViewer.volume_dialog()
                if d == None:
                        return None
                    
                for dr in d.data_regions:
                        if model in dr.models():
                                return dr.data_set
                return None

	def fileselector(self):
		##generate list of open volume files
		self.files=[]
		self.filepath=[]
		self.names=[]
                self.files=filter(lambda x:str(x.__class__)=="VolumeViewer.surface.Surface_Model",chimera.openModels.list())
                for volume in self.files:
                        self.names.append(volume.name)
                        self.filepath.append(self.volume_data_set(volume).data.path)           
		self.fileButton.setitems(self.names)
		
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame1=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame1.grid(column=0,row=1, sticky=EW)

		Label(self.frame0, text='input file:').grid(row=0, column=0, sticky=W)
		self.infile=StringVar()
		self.fileButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.infile)
		self.fileButton.grid(row=0, column=1, sticky=W)
		self.fileselector()

		Label(self.frame1, text='sigma1').grid(row=0, sticky=W)
		Label(self.frame1, text='sigma2').grid(row=1, sticky=W)
		Label(self.frame1, text='iter').grid(row=2, sticky=W)
		Label(self.frame1, text='width').grid(row=3, sticky=W)		
		
		sigma1=StringVar()
		self.sigma1 = Entry(self.frame1, textvariable=sigma1, width = 8)
		sigma1.set("0")
		sigma2=StringVar()
		self.sigma2 = Entry(self.frame1, textvariable=sigma2, width = 8)
		sigma2.set("0")
		iter=StringVar()
		self.iter = Entry(self.frame1, textvariable=iter, width = 8)
		iter.set("0")
		wid=StringVar()
		self.wid = Entry(self.frame1, textvariable=wid, width = 8)
		wid.set("0")

		self.sigma1.grid(row=0, column=1, sticky=W)
		self.sigma2.grid(row=1, column=1, sticky=W)
		self.iter.grid(row=2, column=1, sticky=W)
		self.wid.grid(row=3, column=1, sticky=W)
		
		return self.infile

	def Apply(self):
	    	inputfile = str(self.infile.get())
	    	files=[]
                files=self.filepath
                for path in files:
                        name=path.split('\\')
			n=name[-1]
			name2=n.split('/')
                        checkin=str(name2[-1])
                        if checkin==inputfile:
                                infile=path
                                
		sigma1= str(self.sigma1.get())
		sigma2=str(self.sigma2.get())
		iter=int(self.iter.get())
		width=str(self.wid.get())

		print "Filtering Map"
		outfile="bf-%s"%(inputfile)
		print infile,outfile,sigma1,sigma2,iter,width
		cmd0='proc3d "%s" %s blfilt=%s,%s,%d,%s'%(infile,outfile,sigma1,sigma2,iter,width)
		print cmd0
		os.system(cmd0)
		
		chimera.openModels.open(outfile)
try:
	chimera.dialogs.register(bilateral.name, bilateral)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = bilateral()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) :
                dialog.fileselector()

triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)
		
		
		
		
